package com.company.compsetting.component;

import com.vaadin.flow.component.Composite;
import com.vaadin.flow.component.html.Div;
import com.vaadin.flow.component.icon.Icon;
import com.vaadin.flow.component.icon.VaadinIcon;
import io.jmix.flowui.UiComponents;
import io.jmix.flowui.component.textfield.TypedTextField;

public class CustomComposite extends Composite<Div> {

    private TypedTextField<String> field;
    private Icon icon;

    public CustomComposite(UiComponents uiComponents) {
        field = uiComponents.create(TypedTextField.class);
        icon = VaadinIcon.QUESTION_CIRCLE_O.create();
    }

    @Override
    protected Div initContent() {
        Div content = super.initContent();
        content.add(field, icon);
        return content;
    }

    public String getValue() {
        return field.getValue();
    }

    public void setValue(String value) {
        field.setValue(value);
    }
}
