package com.company.compsetting.component.settings;

import com.company.compsetting.component.CustomComposite;
import com.google.common.base.Strings;
import com.vaadin.flow.component.Component;
import io.jmix.flowui.facet.settings.Settings;
import io.jmix.flowui.facet.settings.component.binder.ComponentSettingsBinder;

@org.springframework.stereotype.Component("CustomCompositeSettingsBinder")
public class CustomCompositeSettingsBinder
        implements ComponentSettingsBinder<CustomComposite, CustomCompositeSettings> {

    @Override
    public Class<? extends Component> getComponentClass() {
        return CustomComposite.class;
    }

    @Override
    public Class<? extends Settings> getSettingsClass() {
        return CustomCompositeSettings.class;
    }

    @Override
    public void applySettings(CustomComposite component, CustomCompositeSettings settings) {
        if (!Strings.isNullOrEmpty(settings.getValue())) {
            component.setValue(settings.getValue());
        }
    }

    @Override
    public boolean saveSettings(CustomComposite component, CustomCompositeSettings settings) {
        if (!Strings.isNullOrEmpty(component.getValue())) {
            settings.setValue(component.getValue());
            return true;
        }
        return false;
    }

    @Override
    public CustomCompositeSettings getSettings(CustomComposite component) {
        CustomCompositeSettings settings = new CustomCompositeSettings();
        settings.setId(component.getId().orElseThrow());
        settings.setValue(component.getValue());
        return settings;
    }
}
